﻿Imports System.Diagnostics
Imports System.Runtime.CompilerServices

Namespace Helpers.BitOperation

	Public Module BitOperationX


		<Extension(), DebuggerStepThrough()>
		Public Sub SetFlag(Of T)(ByRef Subj As T, Value As T, Optional [on] As Boolean = True)
			If [on] Then
				Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Or DirectCast(DirectCast(Value, Object), Integer), Object), T)
			Else
				Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) And Not DirectCast(DirectCast(Value, Object), Integer), Object), T)
			End If
		End Sub

		'<Extension()> _
		'Public Sub SetFlag(Of T)(ByRef Subj As T, Value As Integer, Optional [on] As Boolean = True)
		'   If [on] Then
		'      Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Or Value, Object), T)
		'   Else
		'      Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Or Not Value, Object), T)
		'   End If
		'End Sub

		<Extension(), DebuggerStepThrough()>
		Public Sub [And](Of T)(ByRef Subj As T, Value As T)
			Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) And DirectCast(DirectCast(Value, Object), Integer), Object), T)
		End Sub
		<Extension(), DebuggerStepThrough()>
		Public Sub [Xor](Of T)(ByRef Subj As T, Value As T)
			Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Xor DirectCast(DirectCast(Value, Object), Integer), Object), T)
		End Sub

		<Extension(), DebuggerStepThrough()>
		Public Function HasFlag(Subj As Integer, Value As Integer) As Boolean
			Return (Subj And Value) = Value
		End Function

		<Extension(), DebuggerStepThrough()>
		Public Function HasAnyFlag(Subj As Integer, Value As Integer) As Boolean
			Return CBool(Subj And Value)
		End Function
		''' <summary> bessere Intellisense-Unterstützung als Enum.HasFlag </summary>
		<Extension(), DebuggerStepThrough()>
		Public Function HasFlagX(Of T As {Structure, IComparable, IConvertible})(Subj As T, Value As T) As Boolean
			Return DirectCast(DirectCast(Subj, Object), Integer).HasFlag(DirectCast(DirectCast(Value, Object), Integer))
		End Function
		<Extension(), DebuggerStepThrough()>
		Public Function HasAnyFlag(Of T As {Structure, IComparable, IConvertible})(Subj As T, Value As T) As Boolean
			Return DirectCast(DirectCast(Subj, Object), Integer).HasAnyFlag(DirectCast(DirectCast(Value, Object), Integer))
		End Function

	End Module

End Namespace
