﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics
Imports System.Data

Namespace System
	Public Module EnumX

		Public Function EnumParse(Of T As {Structure, IFormattable, IComparable})(txt As String) As T
			Return DirectCast([Enum].Parse(GetType(T), txt), T)
		End Function
		''' <summary>a typed wrapper around Enum.GetValues</summary>
		<DebuggerStepThrough(), Extension()>
		Public Function EnumGetValues(Of T As {Structure, IFormattable, IComparable})(enm As T) As T()
			Return EnumGetValues(Of T)()
		End Function
		<DebuggerStepThrough(), Extension()>
		Public Sub ThrowIfNotDefined(Of T As {Structure, IFormattable, IComparable})(enm As T)
			If [Enum].IsDefined(GetType(T), enm) Then Return
			Throw New InvalidCastException($"In {GetType(T).Name} ist der Wert {enm} nicht definiert")
		End Sub
		''' <summary>a typed wrapper around Enum.GetValues</summary>
		Public Function EnumGetValues(Of T As {Structure, IFormattable, IComparable})() As T()
			Return DirectCast([Enum].GetValues(GetType(T)), T())
		End Function

		<DebuggerStepThrough(), Extension()>
		Public Function AndChangeAdd(dataRowAction As DataRowAction) As DataRowAction
			Return dataRowAction And (Data.DataRowAction.Add Or Data.DataRowAction.Change)
		End Function

		<DebuggerStepThrough(), Extension()>
		Public Function AndDeletedDetached(dataRowState As DataRowState) As DataRowState
			Return dataRowState And (DataRowState.Deleted Or DataRowState.Detached)
		End Function

	End Module

End Namespace

