﻿Imports System.Runtime.CompilerServices
Imports System.ComponentModel

Namespace System
   <EditorBrowsable(EditorBrowsableState.Never)> _
   Public Module IDisposableX
      Public Interface IAndAlso(Of T)
      End Interface
      Public Class _Andalso(Of T) : Implements IAndAlso(Of T)
         Public Shared ReadOnly Success As New _Andalso(Of T)
      End Class
      <Extension()> _
      Public Function DisposeManaged(Of T As IDisposable)(ByRef First As T, disposing As Boolean) As IAndAlso(Of IDisposable)
         If Not disposing OrElse First Is Nothing Then Return Nothing
         First.Dispose()
         First = Nothing
         Return _Andalso(Of IDisposable).Success
      End Function

      <Extension()> _
      Public Function [AndAlso](subj As IAndAlso(Of IDisposable), ParamArray Disposables As IDisposable()) As IAndAlso(Of IDisposable)
         Return subj.AndAlso(DirectCast(Disposables, IEnumerable(Of IDisposable)))
      End Function

      <Extension()> _
      Public Function [AndAlso](subj As IAndAlso(Of IDisposable), Disposables As IEnumerable(Of IDisposable)) As IAndAlso(Of IDisposable)
         If subj Is Nothing Then Return Nothing
         For Each D As IDisposable In Disposables
            If D IsNot Nothing Then D.Dispose()
         Next
         Return subj
      End Function

   End Module


End Namespace