﻿#Region "FileHeader"
#If False Then
List(Of Tuple(Of T1, T2,...)) ist eigentlich ein einfaches Verfahren, um typisierte mehrspaltige T1bellen zu darzustellen.
Die Verarbeitung derer Datensätze ist aber unleserlich, weil die "SpaltenNamen" lauten unveränderlicherweise "Item1, Item2,...".
Lösung des Problems liegt in Verwendung von Action(Of T1, T2,...)-Delegaten, denn Delegat-Parameter kann man ja lokal sinnvoll benennen

#End If '-- Options, Imports
#End Region 'FileHeader
Imports System.Runtime.CompilerServices

Namespace Global.System.Collections.Generic

	''' <summary> Factory-Methoden für bis zu 6-spaltige TupleLists </summary>
	Public Class TupleList
		Public Shared Function From(Of T1, T2, T3, T4, T5, T6)(a As T1, b As T2, c As T3, d As T4, e As T5, f As T6) As TupleListIniter(Of T1, T2, T3, T4, T5, T6)
			Return (New TupleListIniter(Of T1, T2, T3, T4, T5, T6))(a, b, c, d, e, f)
		End Function
		Public Shared Function From(Of T1, T2, T3, T4, T5)(a As T1, b As T2, c As T3, d As T4, e As T5) As TupleListIniter(Of T1, T2, T3, T4, T5)
			Return (New TupleListIniter(Of T1, T2, T3, T4, T5))(a, b, c, d, e)
		End Function
		Public Shared Function From(Of T1, T2, T3, T4)(a As T1, b As T2, c As T3, d As T4) As TupleListIniter(Of T1, T2, T3, T4)
			Return (New TupleListIniter(Of T1, T2, T3, T4))(a, b, c, d)
		End Function
		Public Shared Function From(Of T1, T2, T3)(a As T1, b As T2, c As T3) As TupleListIniter(Of T1, T2, T3)
			Return (New TupleListIniter(Of T1, T2, T3))(a, b, c)
		End Function
		Public Shared Function From(Of T1, T2)(a As T1, b As T2) As TupleListIniter(Of T1, T2)
			Return (New TupleListIniter(Of T1, T2))(a, b)
		End Function
		Public Shared Function From(Of T1)(a As T1) As TupleListIniter(Of T1)
			Return (New TupleListIniter(Of T1))(a)
		End Function
	End Class ' TupleList

#Region "TupleListIniter"

	Public Class TupleListIniter(Of T1, T2, T3, T4, T5, T6) : Inherits TupleList(Of T1, T2, T3, T4, T5, T6)
		Default Public Shadows ReadOnly Property Adding(a As T1, b As T2, c As T3, d As T4, e As T5, f As T6) As TupleListIniter(Of T1, T2, T3, T4, T5, T6)
			Get
				MyBase.Add(Tuple.Create(a, b, c, d, e, f))
				Return Me
			End Get
		End Property
	End Class
	Public Class TupleListIniter(Of T1, T2, T3, T4, T5) : Inherits TupleList(Of T1, T2, T3, T4, T5)
		Default Public Shadows ReadOnly Property Adding(a As T1, b As T2, c As T3, d As T4, e As T5) As TupleListIniter(Of T1, T2, T3, T4, T5)
			Get
				MyBase.Add(Tuple.Create(a, b, c, d, e))
				Return Me
			End Get
		End Property
	End Class
	Public Class TupleListIniter(Of T1, T2, T3, T4) : Inherits TupleList(Of T1, T2, T3, T4)
		Default Public Shadows ReadOnly Property Adding(a As T1, b As T2, c As T3, d As T4) As TupleListIniter(Of T1, T2, T3, T4)
			Get
				MyBase.Add(Tuple.Create(a, b, c, d))
				Return Me
			End Get
		End Property
	End Class
	Public Class TupleListIniter(Of T1, T2, T3) : Inherits TupleList(Of T1, T2, T3)
		Default Public Shadows ReadOnly Property Adding(a As T1, b As T2, c As T3) As TupleListIniter(Of T1, T2, T3)
			Get
				MyBase.Add(Tuple.Create(a, b, c))
				Return Me
			End Get
		End Property
	End Class
	Public Class TupleListIniter(Of T1, T2) : Inherits TupleList(Of T1, T2)
		Default Public Shadows ReadOnly Property Adding(a As T1, b As T2) As TupleListIniter(Of T1, T2)
			Get
				MyBase.Add(Tuple.Create(a, b))
				Return Me
			End Get
		End Property
	End Class
	Public Class TupleListIniter(Of T1) : Inherits TupleList(Of T1)
		Default Public Shadows ReadOnly Property Adding(a As T1) As TupleListIniter(Of T1)
			Get
				MyBase.Add(Tuple.Create(a))
				Return Me
			End Get
		End Property
	End Class

#End Region' TupleListIniter

#Region "TupleList"

	Public Class TupleList(Of T1, T2, T3, T4, T5, T6) : Inherits List(Of Tuple(Of T1, T2, T3, T4, T5, T6))
		Public Overloads Function Add(a As T1, b As T2, c As T3, d As T4, e As T5, f As T6) As Tuple(Of T1, T2, T3, T4, T5, T6)
			Add = Tuple.Create(a, b, c, d, e, f)
			MyBase.Add(Add)
		End Function
		Public Overloads Function FindIndex(key As T1) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
		End Function
		Public Overloads Function FindIndex(key As T2) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item2))
		End Function
		Public Overloads Function FindIndex(key As T3) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item3))
		End Function
		Public Overloads Function FindIndex(key As T4) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item4))
		End Function
		Public Overloads Function FindIndex(key As T5) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item5))
		End Function
		Public Overloads Function FindIndex(key As T6) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item6))
		End Function
		Public Overloads Function Find(key As T1) As Tuple(Of T1, T2, T3, T4, T5, T6)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T2) As Tuple(Of T1, T2, T3, T4, T5, T6)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T3) As Tuple(Of T1, T2, T3, T4, T5, T6)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T4) As Tuple(Of T1, T2, T3, T4, T5, T6)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T5) As Tuple(Of T1, T2, T3, T4, T5, T6)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T6) As Tuple(Of T1, T2, T3, T4, T5, T6)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function ConvertAll(Of TResult)(converter As Func(Of T1, T2, T3, T4, T5, T6, TResult)) As List(Of TResult)
			Return Me.Select(Function(tpl) converter(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, tpl.Item6)).ToList
		End Function
		Public Overloads Sub ForEach(action As Action(Of T1, T2, T3, T4, T5, T6))
			ForEach(Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, tpl.Item6))
		End Sub
	End Class
	Public Class TupleList(Of T1, T2, T3, T4, T5) : Inherits List(Of Tuple(Of T1, T2, T3, T4, T5))
		Public Overloads Function Add(a As T1, b As T2, c As T3, d As T4, e As T5) As Tuple(Of T1, T2, T3, T4, T5)
			Add = Tuple.Create(a, b, c, d, e)
			MyBase.Add(Add)
		End Function
		Public Overloads Function FindIndex(key As T1) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
		End Function
		Public Overloads Function FindIndex(key As T2) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item2))
		End Function
		Public Overloads Function FindIndex(key As T3) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item3))
		End Function
		Public Overloads Function FindIndex(key As T4) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item4))
		End Function
		Public Overloads Function FindIndex(key As T5) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item5))
		End Function
		Public Overloads Function Find(key As T1) As Tuple(Of T1, T2, T3, T4, T5)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T2) As Tuple(Of T1, T2, T3, T4, T5)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T3) As Tuple(Of T1, T2, T3, T4, T5)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T4) As Tuple(Of T1, T2, T3, T4, T5)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T5) As Tuple(Of T1, T2, T3, T4, T5)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function ConvertAll(Of TResult)(converter As Func(Of T1, T2, T3, T4, T5, TResult)) As List(Of TResult)
			Return Me.Select(Function(tpl) converter(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5)).ToList
		End Function
		Public Overloads Sub ForEach(action As Action(Of T1, T2, T3, T4, T5))
			ForEach(Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5))
		End Sub
	End Class
	Public Class TupleList(Of T1, T2, T3, T4) : Inherits List(Of Tuple(Of T1, T2, T3, T4))
		Public Overloads Function Add(a As T1, b As T2, c As T3, d As T4) As Tuple(Of T1, T2, T3, T4)
			Add = Tuple.Create(a, b, c, d)
			MyBase.Add(Add)
		End Function
		Public Overloads Function FindIndex(key As T1) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
		End Function
		Public Overloads Function FindIndex(key As T2) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item2))
		End Function
		Public Overloads Function FindIndex(key As T3) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item3))
		End Function
		Public Overloads Function FindIndex(key As T4) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item4))
		End Function
		Public Overloads Function Find(key As T1) As Tuple(Of T1, T2, T3, T4)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T2) As Tuple(Of T1, T2, T3, T4)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T3) As Tuple(Of T1, T2, T3, T4)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T4) As Tuple(Of T1, T2, T3, T4)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function ConvertAll(Of TResult)(converter As Func(Of T1, T2, T3, T4, TResult)) As List(Of TResult)
			Return Me.Select(Function(tpl) converter(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4)).ToList
		End Function
		Public Overloads Sub ForEach(action As Action(Of T1, T2, T3, T4))
			ForEach(Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4))
		End Sub
	End Class
	Public Class TupleList(Of T1, T2, T3) : Inherits List(Of Tuple(Of T1, T2, T3))
		Public Overloads Function Add(a As T1, b As T2, c As T3) As Tuple(Of T1, T2, T3)
			Add = Tuple.Create(a, b, c)
			MyBase.Add(Add)
		End Function
		Public Overloads Function FindIndex(key As T1) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
		End Function
		Public Overloads Function FindIndex(key As T2) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item2))
		End Function
		Public Overloads Function FindIndex(key As T3) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item3))
		End Function
		Public Overloads Function Find(key As T1) As Tuple(Of T1, T2, T3)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T2) As Tuple(Of T1, T2, T3)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T3) As Tuple(Of T1, T2, T3)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function ConvertAll(Of TResult)(converter As Func(Of T1, T2, T3, TResult)) As List(Of TResult)
			Return Me.Select(Function(tpl) converter(tpl.Item1, tpl.Item2, tpl.Item3)).ToList
		End Function
		Public Overloads Sub ForEach(action As Action(Of T1, T2, T3))
			ForEach(Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3))
		End Sub
	End Class
	Public Class TupleList(Of T1, T2) : Inherits List(Of Tuple(Of T1, T2))
		Public Overloads Function SetItemAt(index As Integer, a As T1) As Tuple(Of T1, T2)
			SetItemAt = Tuple.Create(a, Me(index).Item2)
			MyBase.Item(index) = SetItemAt
		End Function
		Public Overloads Function SetItemAt(index As Integer, b As T2) As Tuple(Of T1, T2)
			SetItemAt = Tuple.Create(Me(index).Item1, b)
			MyBase.Item(index) = SetItemAt
		End Function
		Public Overloads Function Add(a As T1, b As T2) As Tuple(Of T1, T2)
			Add = Tuple.Create(a, b)
			MyBase.Add(Add)
		End Function
		Public Overloads Function FindIndex(key As T1) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
		End Function
		Public Overloads Function FindIndex(key As T2) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item2))
		End Function
		Public Overloads Function Find(key As T1) As Tuple(Of T1, T2)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function Find(key As T2) As Tuple(Of T1, T2)
			Return Me(FindIndex(key))
		End Function
		Public Overloads Function ConvertAll(Of TResult)(conversion As Func(Of T1, T2, TResult)) As List(Of TResult)
			ConvertAll = New List(Of TResult)(Me.Count)
			ForEach(Sub(tpl) ConvertAll.Add(conversion(tpl.Item1, tpl.Item2)))
		End Function
		Public Overloads Sub ForEach(action As Action(Of T1, T2))
			ForEach(Sub(tpl) action(tpl.Item1, tpl.Item2))
		End Sub
	End Class
	Public Class TupleList(Of T1) : Inherits List(Of Tuple(Of T1))
		Public Overloads Function Add(a As T1) As Tuple(Of T1)
			Add = Tuple.Create(a)
			MyBase.Add(Add)
		End Function
		Public Overloads Function FindIndex(key As T1) As Integer
			Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
		End Function
		Public Overloads Function Find(key As T1) As Tuple(Of T1)
			Return Me(FindIndex(key))
		End Function
	End Class

#End Region'TupleList

	Public Module TupleListX

		<Extension()>
		Public Function FirstOrDefault(Of T1, T2, T3, T4, T5, T6)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5, T6)), predicate As Func(Of T1, T2, T3, T4, T5, T6, Boolean)) As Tuple(Of T1, T2, T3, T4, T5, T6)
			Return tuples.FirstOrDefault(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function FirstOrDefault(Of T1, T2, T3, T4, T5)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5)), predicate As Func(Of T1, T2, T3, T4, T5, Boolean)) As Tuple(Of T1, T2, T3, T4, T5)
			Return tuples.FirstOrDefault(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function FirstOrDefault(Of T1, T2, T3, T4)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4)), predicate As Func(Of T1, T2, T3, T4, Boolean)) As Tuple(Of T1, T2, T3, T4)
			Return tuples.FirstOrDefault(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function FirstOrDefault(Of T1, T2, T3)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3)), predicate As Func(Of T1, T2, T3, Boolean)) As Tuple(Of T1, T2, T3)
			Return tuples.FirstOrDefault(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function FirstOrDefault(Of T1, T2)(tuples As IEnumerable(Of Tuple(Of T1, T2)), predicate As Func(Of T1, T2, Boolean)) As Tuple(Of T1, T2)
			Return tuples.FirstOrDefault(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function FirstOrDefault(Of T1)(tuples As IEnumerable(Of Tuple(Of T1)), predicate As Func(Of T1, Boolean)) As Tuple(Of T1)
			Return tuples.FirstOrDefault(predicate.TuplePredicate)
		End Function

		<Extension()>
		Public Function First(Of T1, T2, T3, T4, T5, T6)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5, T6)), predicate As Func(Of T1, T2, T3, T4, T5, T6, Boolean)) As Tuple(Of T1, T2, T3, T4, T5, T6)
			Return tuples.First(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function First(Of T1, T2, T3, T4, T5)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5)), predicate As Func(Of T1, T2, T3, T4, T5, Boolean)) As Tuple(Of T1, T2, T3, T4, T5)
			Return tuples.First(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function First(Of T1, T2, T3, T4)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4)), predicate As Func(Of T1, T2, T3, T4, Boolean)) As Tuple(Of T1, T2, T3, T4)
			Return tuples.First(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function First(Of T1, T2, T3)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3)), predicate As Func(Of T1, T2, T3, Boolean)) As Tuple(Of T1, T2, T3)
			Return tuples.First(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function First(Of T1, T2)(tuples As IEnumerable(Of Tuple(Of T1, T2)), predicate As Func(Of T1, T2, Boolean)) As Tuple(Of T1, T2)
			Return tuples.First(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function First(Of T1)(tuples As IEnumerable(Of Tuple(Of T1)), predicate As Func(Of T1, Boolean)) As Tuple(Of T1)
			Return tuples.First(predicate.TuplePredicate)
		End Function

		<Extension()>
		Public Function WhereIndx(Of T1, T2, T3, T4, T5, T6)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5, T6)), predicate As Func(Of T1, T2, T3, T4, T5, T6, Integer, Boolean)) As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5, T6))
			Return tuples.Where(predicate.TuplePredicateIndx)
		End Function
		<Extension()>
		Public Function WhereIndx(Of T1, T2, T3, T4, T5)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5)), predicate As Func(Of T1, T2, T3, T4, T5, Integer, Boolean)) As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5))
			Return tuples.Where(predicate.TuplePredicateIndx)
		End Function
		<Extension()>
		Public Function WhereIndx(Of T1, T2, T3, T4)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4)), predicate As Func(Of T1, T2, T3, T4, Integer, Boolean)) As IEnumerable(Of Tuple(Of T1, T2, T3, T4))
			Return tuples.Where(predicate.TuplePredicateIndx)
		End Function
		<Extension()>
		Public Function WhereIndx(Of T1, T2, T3)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3)), predicate As Func(Of T1, T2, T3, Integer, Boolean)) As IEnumerable(Of Tuple(Of T1, T2, T3))
			Return tuples.Where(predicate.TuplePredicateIndx)
		End Function
		<Extension()>
		Public Function WhereIndx(Of T1, T2)(tuples As IEnumerable(Of Tuple(Of T1, T2)), predicate As Func(Of T1, T2, Integer, Boolean)) As IEnumerable(Of Tuple(Of T1, T2))
			Return tuples.Where(predicate.TuplePredicateIndx)
		End Function
		<Extension()>
		Public Function WhereIndx(Of T1)(tuples As IEnumerable(Of Tuple(Of T1)), predicate As Func(Of T1, Integer, Boolean)) As IEnumerable(Of Tuple(Of T1))
			Return tuples.Where(predicate.TuplePredicateIndx)
		End Function

		<Extension()>
		Public Function Where(Of T1, T2, T3, T4, T5, T6)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5, T6)), predicate As Func(Of T1, T2, T3, T4, T5, T6, Boolean)) As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5, T6))
			Return tuples.Where(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function Where(Of T1, T2, T3, T4, T5)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5)), predicate As Func(Of T1, T2, T3, T4, T5, Boolean)) As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5))
			Return tuples.Where(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function Where(Of T1, T2, T3, T4)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4)), predicate As Func(Of T1, T2, T3, T4, Boolean)) As IEnumerable(Of Tuple(Of T1, T2, T3, T4))
			Return tuples.Where(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function Where(Of T1, T2, T3)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3)), predicate As Func(Of T1, T2, T3, Boolean)) As IEnumerable(Of Tuple(Of T1, T2, T3))
			Return tuples.Where(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function Where(Of T1, T2)(tuples As IEnumerable(Of Tuple(Of T1, T2)), predicate As Func(Of T1, T2, Boolean)) As IEnumerable(Of Tuple(Of T1, T2))
			Return tuples.Where(predicate.TuplePredicate)
		End Function
		<Extension()>
		Public Function Where(Of T1)(tuples As IEnumerable(Of Tuple(Of T1)), predicate As Func(Of T1, Boolean)) As IEnumerable(Of Tuple(Of T1))
			Return tuples.Where(predicate.TuplePredicate)
		End Function

		<Extension()>
		Public Function SelectIndx(Of T1, T2, T3, T4, T5, T6, TResult)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5, T6)), selector As Func(Of T1, T2, T3, T4, T5, T6, Integer, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelectorIndx())
		End Function
		<Extension()>
		Public Function SelectIndx(Of T1, T2, T3, T4, T5, TResult)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5)), selector As Func(Of T1, T2, T3, T4, T5, Integer, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelectorIndx())
		End Function
		<Extension()>
		Public Function SelectIndx(Of T1, T2, T3, T4, TResult)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4)), selector As Func(Of T1, T2, T3, T4, Integer, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelectorIndx())
		End Function
		<Extension()>
		Public Function SelectIndx(Of T1, T2, T3, TResult)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3)), selector As Func(Of T1, T2, T3, Integer, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelectorIndx())
		End Function
		<Extension()>
		Public Function SelectIndx(Of T1, T2, TResult)(tuples As IEnumerable(Of Tuple(Of T1, T2)), selector As Func(Of T1, T2, Integer, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelectorIndx())
		End Function
		<Extension()>
		Public Function SelectIndx(Of T1, TResult)(tuples As IEnumerable(Of Tuple(Of T1)), selector As Func(Of T1, Integer, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelectorIndx())
		End Function

		<Extension()>
		Public Function [Select](Of T1, T2, T3, T4, T5, T6, TResult)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5, T6)), selector As Func(Of T1, T2, T3, T4, T5, T6, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelector())
		End Function
		<Extension()>
		Public Function [Select](Of T1, T2, T3, T4, T5, TResult)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5)), selector As Func(Of T1, T2, T3, T4, T5, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelector())
		End Function
		<Extension()>
		Public Function [Select](Of T1, T2, T3, T4, TResult)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4)), selector As Func(Of T1, T2, T3, T4, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelector())
		End Function
		<Extension()>
		Public Function [Select](Of T1, T2, T3, TResult)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3)), selector As Func(Of T1, T2, T3, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelector())
		End Function
		<Extension()>
		Public Function [Select](Of T1, T2, TResult)(tuples As IEnumerable(Of Tuple(Of T1, T2)), selector As Func(Of T1, T2, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelector())
		End Function
#If False Then
		<Extension()>
		Public Function [Select](Of T1, TResult)(tuples As IEnumerable(Of Tuple(Of T1)), selector As Func(Of T1, TResult)) As IEnumerable(Of TResult)
			Return tuples.Select(selector.TupleSelector())
		End Function
#End If

		<Extension()>
		Public Sub ForEach(Of T1, T2, T3, T4, T5, T6)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5, T6)), action As Action(Of T1, T2, T3, T4, T5, T6))
			tuples.ForEach(action.TupleAction)
		End Sub
		<Extension()>
		Public Sub ForEach(Of T1, T2, T3, T4, T5)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5)), action As Action(Of T1, T2, T3, T4, T5))
			tuples.ForEach(action.TupleAction)
		End Sub
		<Extension()>
		Public Sub ForEach(Of T1, T2, T3, T4)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4)), action As Action(Of T1, T2, T3, T4))
			tuples.ForEach(action.TupleAction)
		End Sub
		<Extension()>
		Public Sub ForEach(Of T1, T2, T3)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3)), action As Action(Of T1, T2, T3))
			tuples.ForEach(action.TupleAction)
		End Sub
		<Extension()>
		Public Sub ForEach(Of T1, T2)(tuples As IEnumerable(Of Tuple(Of T1, T2)), action As Action(Of T1, T2))
			tuples.ForEach(action.TupleAction)
		End Sub
		<Extension()>
		Public Sub ForEach(Of T1)(tuples As IEnumerable(Of Tuple(Of T1)), action As Action(Of T1))
			tuples.ForEach(action.TupleAction)
		End Sub

		<Extension()>
		Public Function TuplePredicateIndx(Of T1, T2, T3, T4, T5, T6)(predicate As Func(Of T1, T2, T3, T4, T5, T6, Integer, Boolean)) As Func(Of Tuple(Of T1, T2, T3, T4, T5, T6), Integer, Boolean)
			Return Function(tpl, i) predicate(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, tpl.Item6, i)
		End Function
		<Extension()>
		Public Function TuplePredicateIndx(Of T1, T2, T3, T4, T5)(predicate As Func(Of T1, T2, T3, T4, T5, Integer, Boolean)) As Func(Of Tuple(Of T1, T2, T3, T4, T5), Integer, Boolean)
			Return Function(tpl, i) predicate(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, i)
		End Function
		<Extension()>
		Public Function TuplePredicateIndx(Of T1, T2, T3, T4)(predicate As Func(Of T1, T2, T3, T4, Integer, Boolean)) As Func(Of Tuple(Of T1, T2, T3, T4), Integer, Boolean)
			Return Function(tpl, i) predicate(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, i)
		End Function
		<Extension()>
		Public Function TuplePredicateIndx(Of T1, T2, T3)(predicate As Func(Of T1, T2, T3, Integer, Boolean)) As Func(Of Tuple(Of T1, T2, T3), Integer, Boolean)
			Return Function(tpl, i) predicate(tpl.Item1, tpl.Item2, tpl.Item3, i)
		End Function
		<Extension()>
		Public Function TuplePredicateIndx(Of T1, T2)(predicate As Func(Of T1, T2, Integer, Boolean)) As Func(Of Tuple(Of T1, T2), Integer, Boolean)
			Return Function(tpl, i) predicate(tpl.Item1, tpl.Item2, i)
		End Function
		<Extension()>
		Public Function TuplePredicateIndx(Of T1)(predicate As Func(Of T1, Integer, Boolean)) As Func(Of Tuple(Of T1), Integer, Boolean)
			Return Function(tpl, i) predicate(tpl.Item1, i)
		End Function

		<Extension()>
		Public Function TuplePredicate(Of T1, T2, T3, T4, T5, T6)(predicate As Func(Of T1, T2, T3, T4, T5, T6, Boolean)) As Func(Of Tuple(Of T1, T2, T3, T4, T5, T6), Boolean)
			Return Function(tpl) predicate(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, tpl.Item6)
		End Function
		<Extension()>
		Public Function TuplePredicate(Of T1, T2, T3, T4, T5)(predicate As Func(Of T1, T2, T3, T4, T5, Boolean)) As Func(Of Tuple(Of T1, T2, T3, T4, T5), Boolean)
			Return Function(tpl) predicate(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5)
		End Function
		<Extension()>
		Public Function TuplePredicate(Of T1, T2, T3, T4)(predicate As Func(Of T1, T2, T3, T4, Boolean)) As Func(Of Tuple(Of T1, T2, T3, T4), Boolean)
			Return Function(tpl) predicate(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4)
		End Function
		<Extension()>
		Public Function TuplePredicate(Of T1, T2, T3)(predicate As Func(Of T1, T2, T3, Boolean)) As Func(Of Tuple(Of T1, T2, T3), Boolean)
			Return Function(tpl) predicate(tpl.Item1, tpl.Item2, tpl.Item3)
		End Function
		<Extension()>
		Public Function TuplePredicate(Of T1, T2)(predicate As Func(Of T1, T2, Boolean)) As Func(Of Tuple(Of T1, T2), Boolean)
			Return Function(tpl) predicate(tpl.Item1, tpl.Item2)
		End Function
		<Extension()>
		Public Function TuplePredicate(Of T1)(predicate As Func(Of T1, Boolean)) As Func(Of Tuple(Of T1), Boolean)
			Return Function(tpl) predicate(tpl.Item1)
		End Function

		<Extension()>
		Public Function TupleSelectorIndx(Of T1, T2, T3, T4, T5, T6, TResult)(selector As Func(Of T1, T2, T3, T4, T5, T6, Integer, TResult)) As Func(Of Tuple(Of T1, T2, T3, T4, T5, T6), Integer, TResult)
			Return Function(tpl, i) selector(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, tpl.Item6, i)
		End Function
		<Extension()>
		Public Function TupleSelectorIndx(Of T1, T2, T3, T4, T5, TResult)(selector As Func(Of T1, T2, T3, T4, T5, Integer, TResult)) As Func(Of Tuple(Of T1, T2, T3, T4, T5), Integer, TResult)
			Return Function(tpl, i) selector(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, i)
		End Function
		<Extension()>
		Public Function TupleSelectorIndx(Of T1, T2, T3, T4, TResult)(selector As Func(Of T1, T2, T3, T4, Integer, TResult)) As Func(Of Tuple(Of T1, T2, T3, T4), Integer, TResult)
			Return Function(tpl, i) selector(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, i)
		End Function
		<Extension()>
		Public Function TupleSelectorIndx(Of T1, T2, T3, TResult)(selector As Func(Of T1, T2, T3, Integer, TResult)) As Func(Of Tuple(Of T1, T2, T3), Integer, TResult)
			Return Function(tpl, i) selector(tpl.Item1, tpl.Item2, tpl.Item3, i)
		End Function
		<Extension()>
		Public Function TupleSelectorIndx(Of T1, T2, TResult)(selector As Func(Of T1, T2, Integer, TResult)) As Func(Of Tuple(Of T1, T2), Integer, TResult)
			Return Function(tpl, i) selector(tpl.Item1, tpl.Item2, i)
		End Function
		<Extension()>
		Public Function TupleSelectorIndx(Of T1, TResult)(selector As Func(Of T1, Integer, TResult)) As Func(Of Tuple(Of T1), Integer, TResult)
			Return Function(tpl, i) selector(tpl.Item1, i)
		End Function

		<Extension()>
		Public Function TupleSelector(Of T1, T2, T3, T4, T5, T6, TResult)(selector As Func(Of T1, T2, T3, T4, T5, T6, TResult)) As Func(Of Tuple(Of T1, T2, T3, T4, T5, T6), TResult)
			Return Function(tpl) selector(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, tpl.Item6)
		End Function
		<Extension()>
		Public Function TupleSelector(Of T1, T2, T3, T4, T5, TResult)(selector As Func(Of T1, T2, T3, T4, T5, TResult)) As Func(Of Tuple(Of T1, T2, T3, T4, T5), TResult)
			Return Function(tpl) selector(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5)
		End Function
		<Extension()>
		Public Function TupleSelector(Of T1, T2, T3, T4, TResult)(selector As Func(Of T1, T2, T3, T4, TResult)) As Func(Of Tuple(Of T1, T2, T3, T4), TResult)
			Return Function(tpl) selector(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4)
		End Function
		<Extension()>
		Public Function TupleSelector(Of T1, T2, T3, TResult)(selector As Func(Of T1, T2, T3, TResult)) As Func(Of Tuple(Of T1, T2, T3), TResult)
			Return Function(tpl) selector(tpl.Item1, tpl.Item2, tpl.Item3)
		End Function
		<Extension()>
		Public Function TupleSelector(Of T1, T2, TResult)(selector As Func(Of T1, T2, TResult)) As Func(Of Tuple(Of T1, T2), TResult)
			Return Function(tpl) selector(tpl.Item1, tpl.Item2)
		End Function
		<Extension()>
		Public Function TupleSelector(Of T1, TResult)(selector As Func(Of T1, TResult)) As Func(Of Tuple(Of T1), TResult)
			Return Function(tpl) selector(tpl.Item1)
		End Function

		<Extension()>
		Public Sub ForIndx(Of T1, T2, T3, T4, T5, T6)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5, T6)), action As Action(Of T1, T2, T3, T4, T5, T6, Integer))
			tuples.ForIndx(action.TupleActionIndx)
		End Sub
		<Extension()>
		Public Sub ForIndx(Of T1, T2, T3, T4, T5)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4, T5)), action As Action(Of T1, T2, T3, T4, T5, Integer))
			tuples.ForIndx(action.TupleActionIndx)
		End Sub
		<Extension()>
		Public Sub ForIndx(Of T1, T2, T3, T4)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3, T4)), action As Action(Of T1, T2, T3, T4, Integer))
			tuples.ForIndx(action.TupleActionIndx)
		End Sub
		<Extension()>
		Public Sub ForIndx(Of T1, T2, T3)(tuples As IEnumerable(Of Tuple(Of T1, T2, T3)), action As Action(Of T1, T2, T3, Integer))
			tuples.ForIndx(action.TupleActionIndx)
		End Sub
		<Extension()>
		Public Sub ForIndx(Of T1, T2)(tuples As IEnumerable(Of Tuple(Of T1, T2)), action As Action(Of T1, T2, Integer))
			tuples.ForIndx(action.TupleActionIndx)
		End Sub
		<Extension()>
		Public Sub ForIndx(Of T1)(tuples As IEnumerable(Of Tuple(Of T1)), action As Action(Of T1, Integer))
			tuples.ForIndx(action.TupleActionIndx)
		End Sub
		<Extension()>
		Public Function TupleActionIndx(Of T1, T2, T3, T4, T5, T6)(action As Action(Of T1, T2, T3, T4, T5, T6, Integer)) As Action(Of Tuple(Of T1, T2, T3, T4, T5, T6), Integer)
			Return Sub(tpl, i) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, tpl.Item6, i)
		End Function
		<Extension()>
		Public Function TupleActionIndx(Of T1, T2, T3, T4, T5)(action As Action(Of T1, T2, T3, T4, T5, Integer)) As Action(Of Tuple(Of T1, T2, T3, T4, T5), Integer)
			Return Sub(tpl, i) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, i)
		End Function
		<Extension()>
		Public Function TupleActionIndx(Of T1, T2, T3, T4)(action As Action(Of T1, T2, T3, T4, Integer)) As Action(Of Tuple(Of T1, T2, T3, T4), Integer)
			Return Sub(tpl, i) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, i)
		End Function
		<Extension()>
		Public Function TupleActionIndx(Of T1, T2, T3)(action As Action(Of T1, T2, T3, Integer)) As Action(Of Tuple(Of T1, T2, T3), Integer)
			Return Sub(tpl, i) action(tpl.Item1, tpl.Item2, tpl.Item3, i)
		End Function
		<Extension()>
		Public Function TupleActionIndx(Of T1, T2)(action As Action(Of T1, T2, Integer)) As Action(Of Tuple(Of T1, T2), Integer)
			Return Sub(tpl, i) action(tpl.Item1, tpl.Item2, i)
		End Function
		<Extension()>
		Public Function TupleActionIndx(Of T1)(action As Action(Of T1, Integer)) As Action(Of Tuple(Of T1), Integer)
			Return Sub(tpl, i) action(tpl.Item1, i)
		End Function

		<Extension()>
		Public Function TupleAction(Of T1, T2, T3, T4, T5, T6)(action As Action(Of T1, T2, T3, T4, T5, T6)) As Action(Of Tuple(Of T1, T2, T3, T4, T5, T6))
			Return Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, tpl.Item6)
		End Function
		<Extension()>
		Public Function TupleAction(Of T1, T2, T3, T4, T5)(action As Action(Of T1, T2, T3, T4, T5)) As Action(Of Tuple(Of T1, T2, T3, T4, T5))
			Return Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5)
		End Function
		<Extension()>
		Public Function TupleAction(Of T1, T2, T3, T4)(action As Action(Of T1, T2, T3, T4)) As Action(Of Tuple(Of T1, T2, T3, T4))
			Return Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4)
		End Function
		<Extension()>
		Public Function TupleAction(Of T1, T2, T3)(action As Action(Of T1, T2, T3)) As Action(Of Tuple(Of T1, T2, T3))
			Return Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3)
		End Function
		<Extension()>
		Public Function TupleAction(Of T1, T2)(action As Action(Of T1, T2)) As Action(Of Tuple(Of T1, T2))
			Return Sub(tpl) action(tpl.Item1, tpl.Item2)
		End Function
		<Extension()>
		Public Function TupleAction(Of T1)(action As Action(Of T1)) As Action(Of Tuple(Of T1))
			Return Sub(tpl) action(tpl.Item1)
		End Function

		''' <summary> combines elements to TResult, in order of occurance. Terminates at end of shortest list</summary>
		<Extension()>
		Public Iterator Function Zip(Of T1, T2, T3, TResult)(lst1 As IEnumerable(Of T1), lst2 As IEnumerable(Of T2), lst3 As IEnumerable(Of T3), selector As Func(Of T1, T2, T3, TResult)) As IEnumerable(Of TResult)
			' Entspricht genau der Linq.Zip-Extension - nur mit 3 Listen
			Using e1 = lst1.GetEnumerator, e2 = lst2.GetEnumerator, e3 = lst3.GetEnumerator
				While e1.MoveNext AndAlso e2.MoveNext AndAlso e3.MoveNext
					Yield selector(e1.Current, e2.Current, e3.Current)
				End While
			End Using
		End Function
		''' <summary> combines elements to Tuples, in order of occurance. Terminates at end of shortest list</summary>
		<Extension()>
		Public Function Zip(Of T1, T2, T3, TResult)(lst1 As IEnumerable(Of T1), lst2 As IEnumerable(Of T2), lst3 As IEnumerable(Of T3)) As TupleList(Of T1, T2, T3)
			Zip = New TupleList(Of T1, T2, T3)
			Zip.AddRange(lst1.Zip(lst2, lst3, AddressOf Tuple.Create))
		End Function
		''' <summary> combines elements to Tuples, in order of occurance. Terminates at end of shorter list</summary>
		<Extension()>
		Public Function Zip(Of T1, T2)(lst1 As IEnumerable(Of T1), lst2 As IEnumerable(Of T2)) As TupleList(Of T1, T2)
			Zip = New TupleList(Of T1, T2)
			Zip.AddRange(lst1.Zip(lst2, AddressOf Tuple.Create))
		End Function

	End Module

End Namespace