﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
DataTableAttach wird  als ComponentProperty an typisierte DataTables angefügt, und stellt folgende Funktionalität bereit:

Persistance: Eine Info für DatasetAdapter, ob die Tabelle zu persistieren ist

SuspendLogic.vb: ruft temporär Table.BeginUpdate auf, und setzt alle angehängten BindingSources auf RaiseListChangedEvents.False

LoadingEvent.vb: SuspendLogic feuert ein kunstvolles Loading-Event, was ermöglicht, Business-Logik während Ladevorgängen zu deaktivieren.
In partialen typisierten DataTables kann das eigene DataTableAttach als WithEvents-Variable instanziert werden.

SuspendOnDeleteCascade.vb: Das Gui kann schwer laggen, wenn Löschweitergabe eine Kaskade untergeordneter Löschungen auslöst. Daher SuspendLogic untergeordneter BindingSources

CurrentTracking.vb: Eine DataRow kann als Current bestimmt werden. Dazu können sich BindingSources extra registrieren, die dann mit Current synchronisiert werden. 
In Dataset.Initialized kann man ParentNotifications festlegen - dann werden die entsprechenden übergeordneten DataTableAttaches auch synchronisiert, sodass zb. automatisch die richtige Kategorie zum angewählten Artikel eingestellt ist.

DatasetAttach.vb: Unterstützung der Dataset.SuspendConstraints-Extension, um Constraints in einem Using-Block zu suspendieren.

## Unterstützende Extensions in XDataTableAttach.vb ##
DataTable.Attach: returnt das zugehörige DataTableAttach
DataTable.Persist(Boolean): setzt Persistenz der DataTable - alle anneren wern gegenteilig gesetzt
DataSet.Persist(Boolean, DataTable()): setzt Persistenz der aufgeführten DataTables - alle anneren wern gegenteilig gesetzt
DataSet.PersistAll: setzt Persistenz aller DataTables auf True
TypedTableBase.Current: returnt/setzt eine Datarow als Current
DataTable.SetParentNotifications: setzt Current-Mitführung übergeordneter DataTableAttaches
BindingSource.RegisterCurrency: setzt Current-Synchronisierung mit einer BindingSource
DataSet.RegisterCurrency(BindingSource()): setzt Current-Synchronisierung  der aufgeführten BindingSources
XDatasetAdapter.vb - DataSet.SuspendConstraints(): ermöglicht Constraints in einem Using-Block zu suspendieren
XDatasetAdapter.vb - DataSet.Register(Form, handleFormClosing As Boolean): registriert (u.a.) alle im Form vorgefundenen Bindingsources als suspendable
#End If ' -------------- Imports & Options --------------------
#End Region 'FileHeader

Namespace System.Data

   <Flags()> _
   Public Enum Persistance As Integer : No = 1 : Yes = 2 : Guess = 4 : YesOrGuess = 6 : End Enum

   ''' <summary>stores Stuff to suspend databinding-events</summary>
   <DebuggerDisplay("{Table.TableName}")> _
   Public Class DataTableAttach

      Public Persistance As Persistance = Data.Persistance.Guess
      Private _Dataset_Attach As DatasetAttach
      Public ReadOnly Table As DataTable
      Private _DefaultValues As DataRow
      Private _ParentRels As DataRelation()
      Public ReadOnly Property DefaultValues As DataRow
         Get
            If _DefaultValues.Null Then _DefaultValues = Table.NewRow
            For Each col As DataColumn In Table.Columns
               _DefaultValues(col) = col.DefaultValue
            Next
            Return _DefaultValues
         End Get
      End Property
      Private WithEvents _ActiveTable As DataTable
      Private Sub DataTableAttach_Suspending(sender As Object, e As SuspendingEventArgs) Handles Me.Suspending
         If e.Suspended > Suspend.NotifyOnly Then e.TriDecide(_ActiveTable, Nothing, Table)
      End Sub

      Public ReadOnly Property Dataset_Attach() As DatasetAttach
         Get
            If _Dataset_Attach.Null Then Dim x = New DatasetAttach(Table.DataSet)
            Return _Dataset_Attach
         End Get
      End Property

      Public Sub New(tb As DataTable)
         Table = tb
         _ParentRels = Table.ParentRelations.Cast(Of DataRelation).ToArray
         _ActiveTable = tb
         AddHandler Table.Disposed, AddressOf _Table_Disposed
      End Sub

      Private Sub _Table_Disposed(sender As Object, e As EventArgs)
         If _Dataset_Attach.Null Then Return
         For Each bs In SuspendableBindingSources
            RemoveHandler bs.Disposed, AddressOf SuspendableBindingSource_Disposed
         Next
         For Each bs In _CurrencyBindingsources
            RemoveHandler bs.CurrentChanged, AddressOf bs_CurrentChanged
         Next
         RemoveHandler Table.Disposed, AddressOf _Table_Disposed
         _Dataset_Attach = Nothing
      End Sub

      Private Sub _Active_RowChanged(sender As Object, e As DataRowChangeEventArgs) Handles _ActiveTable.RowChanged
         'Führt dazu, dass zukünftig neue Datensätze dieselben Parents erhalten wie zuletzt added/changed
         If (DataRowAction.Add Or DataRowAction.Change).HasFlag(e.Action) Then SetForeignKeyValueDefaults(e.Row)
      End Sub

      Private Sub SetForeignKeyValueDefaults(rw As DataRow)
         'If rw Is Nothing Then
         '    rw = DefaultValues
         '    For Each rl In _ParentRels.Where(Function(x) rw.GetParentRow(x) Is Nothing)
         '        rw.SetParentRow(rl.ParentTable.All.First)
         '    Next
         'End If
         For Each rl In _ParentRels
            For Each col In rl.ChildColumns
               col.DefaultValue = rw(col)
            Next
         Next
      End Sub

   End Class

End Namespace
