﻿#Region "FileHeader"
#If False Then
a popup-Window in .net is rather strange: create a ToolStripDropDown and add a ToolstripItem. Then you can dropdown the ToolStripDropDown whereever you want. You can even attach it to a target-Control (as shown below)
#End If '-- Options, Imports
#End Region 'FileHeader

Namespace System.Windows.Forms

   Public Class PopUpText
      Private _DropDown As New ToolStripDropDown

      Public ReadOnly Visual As ToolStripItem
      Public WithEvents Target As Control
      Public Relative As New Point(0, -5)
      Public Direction As ToolStripDropDownDirection = ToolStripDropDownDirection.AboveRight
      Private _TargetLocation As Point

      Public Sub New()
         Visual = New ToolStripLabel("")
         _DropDown.Items.Add(Visual)
         _DropDown.AutoClose = False
      End Sub

      Public Sub FontName(name As String)
         If Visual.Font.Name = name Then Return
         Visual.Font = New Font(name, Target.Font.Size)
      End Sub

      Public Property Text() As String
         Get
            Return Visual.Text
         End Get
         Set(value As String)
            If Visual.Text = value Then Return
            Visual.Text = value
            UpdateVisible()
         End Set
      End Property

      Private Sub UpdateVisible()
         With _DropDown
            If .Visible AndAlso Target.PointToScreen(Point.Empty) <> _TargetLocation Then .Close()
            Dim value = Target.Visible AndAlso Visual.Text.Length > 0
            If .Visible = value Then Return
            If value Then
               _DropDown.Show(Target, Relative, Direction)
               _TargetLocation = Target.PointToScreen(Point.Empty)
            Else
               .Close()
            End If
         End With
      End Sub

      Private Sub Target_VisibleChanged(sender As Object, e As EventArgs) Handles Target.VisibleChanged
         UpdateVisible()
      End Sub
   End Class
End Namespace
