﻿Imports System.ComponentModel
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Windows.Forms

Namespace System.Windows.Forms

	<DesignerCategory("code"), DefaultEvent("Paint")>
	Public Class OwnerDrawn : Inherits Control

		''' <summary>Quell-Rechteck, was OwnerDrawn.Matrix immer auf die OwnerDrawn-Abmasse transformiert </summary>
		Public VirtualRect As New RectangleF(-10, -10, 20, 20)
		Protected Overrides Sub OnHandleCreated(e As System.EventArgs)
			MyBase.OnHandleCreated(e)
			MyBase.SetStyle(ControlStyles.ResizeRedraw, True)
		End Sub

		<Category("Appearance")>
		Public Shadows Property DoubleBuffered As Boolean
			Get
				Return MyBase.DoubleBuffered
			End Get
			Set(value As Boolean)
				MyBase.DoubleBuffered = value
			End Set
		End Property
		Protected Overrides Sub OnPaint(e As PaintEventArgs)
			With Me
				If NotifyPropertyChanged.IsInDesignMode Then TextRenderer.DrawText(e.Graphics, .Name, .Font, Point.Empty, .ForeColor)
			End With
			MyBase.OnPaint(e)
		End Sub

		Private _Matrix As Matrix
		<DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
		Public Property Matrix() As Matrix
			Get
				Return _Matrix
			End Get
			Set(value As Matrix)
				If _Matrix Is value Then Return
				If _Matrix IsNot Nothing Then _Matrix.Dispose()
				_Matrix = value
			End Set
		End Property
		Protected Overrides Sub Dispose(disposing As Boolean)
			Try
				If disposing AndAlso _Matrix IsNot Nothing Then Matrix = Nothing
			Finally
				MyBase.Dispose(disposing)
			End Try
		End Sub
		Private Sub OwnerDrawn1_SizeChanged(sender As Object, e As EventArgs) Handles Me.SizeChanged
			Matrix = New Matrix(VirtualRect, {Point.Empty, New Point(Width, 0), New Point(0, Height)})
			DbgCaller()
		End Sub

		Public Sub DrawPath(g As Graphics, gp As GraphicsPath, pen As Pen)
			PaintPathCore(g, gp, pen)
		End Sub
		Public Sub FillPath(g As Graphics, gp As GraphicsPath, brsh As Brush)
			PaintPathCore(g, gp,, brsh)
		End Sub
		Private Sub PaintPathCore(g As Graphics, gp As GraphicsPath, Optional pen As Pen = Nothing, Optional brsh As Brush = Nothing)
			DbgCaller()

			Using gpDraw = gp.CloneX
				gpDraw.Transform(_Matrix)
				If brsh.Null Then g.DrawPath(pen, gpDraw) Else g.FillPath(brsh, gpDraw)
			End Using
		End Sub

	End Class

End Namespace