﻿#Region "FileHeader"
#If False Then
verwaltet eine Gruppe von Radiobuttons und verfolgt, welche checked ist.
Mittels Checked-Property, aber auch mittels CheckedChanged-Event.
Die RBs können auch auf unterschiedlichen Containern liegen.
Initialisiert wird nicht durch Angabe der RBs, sondern durch Angabe der Container, in denen die RBs liegen.
Liegen also Rb1, Rb2, Rb3 in Container1, und Rb4, Rb5 in Container2, so initialisiert man wohl am einfachsten durch:
_MyRadioGroupBehavior = new RadioGroupBehavior(Rb1.Parent, Rb4.Parent)
#End If '-- Options, Imports
#End Region 'FileHeader
Namespace Global.System.Windows.Forms

	''' <summary>Organisationseinheit mehrerer Radiobuttons, um immer zu wissen, welcher checked ist</summary>
	Public Class RadioGroupBehavior

		Public Event CheckedChanged As EventHandler
		Private _RBs As RadioButton()
		Private _Checked As RadioButton

		Private _CheckHandler As EventHandler = Sub(sender As Object, e As EventArgs)
																 Dim rb = DirectCast(sender, RadioButton)
																 If rb.Checked Then Checked = rb
															 End Sub

		''' <summary>Initialisiert wird durch Angabe der Container, in denen die RBs liegen</summary>
		Public Sub New(ParamArray containers As Control())
			_RBs = containers.SelectMany(Function(c) c.Controls.OfType(Of RadioButton)).ToArray
			_RBs.ForEach(Sub(rb) rb.Checked = False)
			WireEvent(True)
		End Sub
		Public Property Checked() As RadioButton
			Get
				Return _Checked
			End Get
			Set(value As RadioButton)
				If value Is _Checked Then Return
				If value IsNot Nothing AndAlso Not _RBs.Contains(value) Then Throw New ArgumentException("value muss ein bekannter RadioButton sein, oder Nothing")
				_Checked = value
				WireEvent(False)
				_RBs.ForEach(Sub(rb) rb.Checked = rb Is _Checked)
				WireEvent(True)
				RaiseEvent CheckedChanged(Me, EventArgs.Empty)
			End Set
		End Property
		Private Sub WireEvent(value As Boolean)
			If value Then
				_RBs.ForEach(Sub(rb) AddHandler rb.CheckedChanged, _CheckHandler)
			Else
				_RBs.ForEach(Sub(rb) RemoveHandler rb.CheckedChanged, _CheckHandler)
			End If
		End Sub
	End Class

End Namespace
