﻿#Region "FileHeader"
#If False Then
Ein Dgv-Behavior, was Doubles als Timespan-Strings präsentiert ("h:mm"), incl. Editierbarkeit
#End If '-- Options, Imports
#End Region 'FileHeader

Namespace System.Windows.Forms
   Public Class TimeDoubleDgvBehavior

      Private WithEvents _Dgv As DataGridView
      Private ReadOnly _ObservedIndicees As HashSet(Of Integer)

      Public Sub New(dgv As DataGridView, timeDoubleDataColumns As IEnumerable(Of DataColumn))
         _Dgv = dgv
         If timeDoubleDataColumns.Any(Function(clm) clm.DataType IsNot GetType(Double)) Then Throw Me.Exception("Alle angegebenen Spalten müssen DataType.Double aufweisen")
         _ObservedIndicees = New HashSet(Of Integer)(From dgvClm In dgv.Columns.OfType(Of DataGridViewTextBoxColumn)()
               Join clm In timeDoubleDataColumns On dgvClm.DataPropertyName Equals clm.ColumnName Select dgvClm.Index)
      End Sub

      Private Sub _Dgv_CellFormatting(sender As Object, e As DataGridViewCellFormattingEventArgs) Handles _Dgv.CellFormatting
         If Not _ObservedIndicees.Contains(e.ColumnIndex) Then Return
         e.FormattingApplied = True
         Try
            Dim val = CDbl(e.Value)
            If e.RowIndex = _Dgv.RowCount - 1 AndAlso _Dgv.AllowUserToAddRows AndAlso val = 0.0 Then
               e.Value = "" ' in der Zufügezeile werden null-Werte ausgeblendet
            Else
               e.Value = TimeDoubleBehavior.Double2TimeString(val)
            End If
         Catch ex As Exception
            e.Value = "Err"
         End Try
      End Sub

      Private Sub _Dgv_CellParsing(sender As Object, e As DataGridViewCellParsingEventArgs) Handles _Dgv.CellParsing
         If Not _ObservedIndicees.Contains(e.ColumnIndex) Then Return
         e.ParsingApplied = True
         e.Value = TimeDoubleBehavior.TimeString2Double(e.Value.ToString)
      End Sub

   End Class


End Namespace